#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	ofSetVerticalSync(true);
	ofBackground(255, 255, 255);
	
	//setup some rectangles
	for(int i = 0; i <5; i++)
	{	
		rect = rectangle();
		rect.pos.x = ofRandom(0,  ofGetWidth());
		rect.pos.y = ofRandom(0,  ofGetHeight());
		rects.push_back(rect);
	}
	
	//boolean to decide whether or not to show lines, press l
	b_showLines = true;

}

//--------------------------------------------------------------
void testApp::update(){
		
	//update particles in vector, start with the first followin the mouse and make the rest follow its parent
	for(int i = 0; i < rects.size(); i++)
	{	
		if(i == 0) 	rects[i].followMouse(mouseX,mouseY);
		else 
		{
			rects[i].followMouse(rects[i-1].pos.x,rects[i-1].pos.y);
		}

	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	//draw curves from each rect to the previous. factored the distance into curves to make it a bit more fluid.
	for(int i = 0; i < rects.size(); i++)
	{
		if(b_showLines)
		{
		if(i >= 1)
		{
			ofNoFill(); 
			float dist = ofDist(rects[i-1].pos.x,rects[i-1].pos.y, rects[i].pos.x, rects[i].pos.y);
			ofSetColor(255,100+(i*1.5),100+(i*1.5),10);
			ofCurve(rects[i].pos.x+(dist*2),
					rects[i-1].pos.y+(dist/2),
					rects[i-1].pos.x,
					rects[i-1].pos.y, 
					rects[i].pos.x, 
					rects[i].pos.y,
					rects[i].pos.x+(dist/2),
					rects[i-1].pos.y+(dist*2));
			ofCurve(rects[i-1].pos.x-(dist*2),
					rects[i].pos.y-(dist/2),
					rects[i-1].pos.x,
					rects[i-1].pos.y, 
					rects[i].pos.x, 
					rects[i].pos.y,
					rects[i-1].pos.x-(dist*2),
					rects[i].pos.y-(dist/2));
			if(dist <=40)
			{
			ofSetColor(150, 150, 150);
			ofLine(rects[i-1].pos.x,
				   rects[i-1].pos.y, 
				   rects[i].pos.x, 
				   rects[i].pos.y);
			}
			
		}
		}
		rects[i].draw();

	}
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	
	//turn on or off lines
	if(key == 'l')
	{
		(b_showLines == false) ? b_showLines = true : b_showLines = false;
	}
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	//create a new paricle
	rect = rectangle();
	rect.pos.x = ofRandom(0, ofGetWidth());
	rect.pos.y = ofRandom(0, ofGetHeight());
	rects.push_back(rect);
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

